/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreLogic.TCoreLogicPath;
import de.ship.db.tables.records.TCoreLogiclistRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLogiclist extends TableImpl<TCoreLogiclistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_logiclist</code>
     */
    public static final TCoreLogiclist T_CORE_LOGICLIST = new TCoreLogiclist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLogiclistRecord> getRecordType() {
        return TCoreLogiclistRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_logiclist.lastchange</code>.
     */
    public final TableField<TCoreLogiclistRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_logiclist.pk</code>.
     */
    public final TableField<TCoreLogiclistRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_logiclist.fk_core_logic</code>. Foreign
     * key to t_core_logic
     */
    public final TableField<TCoreLogiclistRecord, Integer> FK_CORE_LOGIC = createField(DSL.name("fk_core_logic"), SQLDataType.INTEGER.nullable(false), this, "Foreign key to t_core_logic");

    /**
     * The column <code>common_dd.t_core_logiclist.list_number</code>. Groups
     * entries to a list
     */
    public final TableField<TCoreLogiclistRecord, Integer> LIST_NUMBER = createField(DSL.name("list_number"), SQLDataType.INTEGER.nullable(false), this, "Groups entries to a list");

    private TCoreLogiclist(Name alias, Table<TCoreLogiclistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLogiclist(Name alias, Table<TCoreLogiclistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logiclist</code> table reference
     */
    public TCoreLogiclist(String alias) {
        this(DSL.name(alias), T_CORE_LOGICLIST);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logiclist</code> table reference
     */
    public TCoreLogiclist(Name alias) {
        this(alias, T_CORE_LOGICLIST);
    }

    /**
     * Create a <code>common_dd.t_core_logiclist</code> table reference
     */
    public TCoreLogiclist() {
        this(DSL.name("t_core_logiclist"), null);
    }

    public <O extends Record> TCoreLogiclist(Table<O> path, ForeignKey<O, TCoreLogiclistRecord> childPath, InverseForeignKey<O, TCoreLogiclistRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LOGICLIST);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLogiclistPath extends TCoreLogiclist implements Path<TCoreLogiclistRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLogiclistPath(Table<O> path, ForeignKey<O, TCoreLogiclistRecord> childPath, InverseForeignKey<O, TCoreLogiclistRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLogiclistPath(Name alias, Table<TCoreLogiclistRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLogiclistPath as(String alias) {
            return new TCoreLogiclistPath(DSL.name(alias), this);
        }

        @Override
        public TCoreLogiclistPath as(Name alias) {
            return new TCoreLogiclistPath(alias, this);
        }

        @Override
        public TCoreLogiclistPath as(Table<?> alias) {
            return new TCoreLogiclistPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreLogiclistRecord, Integer> getIdentity() {
        return (Identity<TCoreLogiclistRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreLogiclistRecord> getPrimaryKey() {
        return Keys.PK_CORE_LOGICLIST;
    }

    @Override
    public List<ForeignKey<TCoreLogiclistRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_LOGICLIST__FK_CORE_LOGICLIST_LOGIC);
    }

    private transient TCoreLogicPath _tCoreLogic;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_logic</code>
     * table.
     */
    public TCoreLogicPath tCoreLogic() {
        if (_tCoreLogic == null)
            _tCoreLogic = new TCoreLogicPath(this, Keys.T_CORE_LOGICLIST__FK_CORE_LOGICLIST_LOGIC, null);

        return _tCoreLogic;
    }

    @Override
    public TCoreLogiclist as(String alias) {
        return new TCoreLogiclist(DSL.name(alias), this);
    }

    @Override
    public TCoreLogiclist as(Name alias) {
        return new TCoreLogiclist(alias, this);
    }

    @Override
    public TCoreLogiclist as(Table<?> alias) {
        return new TCoreLogiclist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogiclist rename(String name) {
        return new TCoreLogiclist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogiclist rename(Name name) {
        return new TCoreLogiclist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogiclist rename(Table<?> name) {
        return new TCoreLogiclist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiclist where(Condition condition) {
        return new TCoreLogiclist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiclist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiclist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiclist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiclist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiclist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiclist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiclist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiclist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiclist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
